/*
 * Copyright 2010 Sergey Martynov http://studiomobile.ru
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.studiomobile.http;

import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpRequest;
import org.apache.http.nio.reactor.IOReactorStatus;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.URL;

public interface HttpClient {

    HttpRequestFuture executeRequest(InetSocketAddress address, HttpRequest request);

    HttpRequestFuture head(URL url, Header... headers);

    HttpRequestFuture get(URL url, Header... headers);

    HttpRequestFuture post(URL url, HttpEntity entity, Header... headers);

    HttpRequestFuture put(URL url, HttpEntity entity, Header... headers);

    HttpRequestFuture delete(URL url, Header... headers);

    IOReactorStatus getStatus();

    void shutdown(long waitMs) throws IOException;

    void shutdown() throws IOException;
}
